/**
 * \file
 * \brief  Service
 */
/*
 * (c) 2008-2009 Technische Universität Dresden
 * This file is part of TUD:OS and distributed under the terms of the
 * GNU General Public License 2.
 * Please see the COPYING-GPL-2 file for details.
 *
 * As a special exception, you may use this file as part of a free software
 * library without restriction.  Specifically, if other files instantiate
 * templates or use macros or inline functions from this file, or you compile
 * this file and link it with other files to produce an executable, this
 * file does not by itself cause the resulting executable to be covered by
 * the GNU General Public License.  This exception does not however
 * invalidate any other reasons why the executable file might be covered by
 * the GNU General Public License.
 */
#include <l4/cxx/ipc_stream>

#include <l4/re/service>
#include <l4/re/service-sys.h>
#include <l4/re/protocols>

long
L4Re::Service::open(L4::Cap<L4::Kobject> target,
                    const char *data, unsigned long len) const throw()
{
  L4::Ipc_iostream io(l4_utcb());
  io << L4::Opcode(Service_::Open)
     << L4::ipc_buf_cp_out(data, len);
  io << L4::Small_buf(target.cap());
  return l4_error(io.call(cap(), L4Re::Protocol::Service));
}
