/*
 * (c) 2008-2009 Technische Universität Dresden
 * This file is part of TUD:OS and distributed under the terms of the
 * GNU General Public License 2.
 * Please see the COPYING-GPL-2 file for details.
 */
#pragma once

#include <l4/re/l4aux.h>
#include <l4/util/bitops.h>

#include "remote_mem.h"
#include "app_task.h"

namespace Ldr {
class Script;
};

class Loader
{
public:

  struct Info
  {
    l4_addr_t entry;
    Stack stack;
    l4_addr_t utcbs_start;
    unsigned char utcbs_log2size;
    l4_addr_t kip;

    Info() : kip(0) {}
  };

  virtual bool check_file_type(L4::Cap<L4Re::Dataspace> bin) const = 0;
  bool start(char const *name);
  bool exec(Ldr::Script *);
  bool launch(App_task *, Ldr::Script *);
  virtual bool load(L4::Cap<L4Re::Dataspace> bin, App_task *task, Info *info) = 0;
  virtual bool read_infos(L4::Cap<L4Re::Dataspace> bin, Info *info) = 0;
  virtual ~Loader() {}
};
